﻿using System;
using Amplitude.AI.Core.Framework.BehaviorTree;
using Amplitude.AI.Core.Framework.BehaviorTree.BehaviorNodes;
using Amplitude.AI.Core.Framework.BehaviorTree.BehaviorNodes.Composites;
using Amplitude.AI.Core.Framework.Debug;

namespace Amplitude.AI.Core.Brain.Behaviors.Fleet
{
    public abstract class DoFleetActionAtPosition : BehaviorTree<BehaviorData>
    {
        protected abstract BehaviorNode<BehaviorData> GetAction();

        protected override BehaviorNode<BehaviorData> GenerateRoot()
        {
            BehaviorNode<BehaviorData> behaviorNode = new Condition<BehaviorData>(new Func<BehaviorData, HeuristicBool>(BehaviorConditions.IsAtDestination));
            BehaviorNode<BehaviorData> behaviorNode2 = new Condition<BehaviorData>(new Func<BehaviorData, HeuristicBool>(BehaviorConditions.IsFleetInOrbit));
            BehaviorNode<BehaviorData> behaviorNode3 = new Amplitude.AI.Core.Framework.BehaviorTree.BehaviorNodes.Action<BehaviorData>(new Func<BehaviorData, BehaviorNodeReturnCode>(BehaviorActions.OptionalyWaitUntilNextSync));
            BehaviorNode<BehaviorData> action = this.GetAction();
            BehaviorNode<BehaviorData> behaviorNode4 = BehaviorSubTrees.GeAttackInOrbitSubtree();
            BehaviorNode<BehaviorData> behaviorNode5 = new Sequence<BehaviorData>(new BehaviorNode<BehaviorData>[]
			{
				behaviorNode,
				action,
				behaviorNode3
			});
            BehaviorNode<BehaviorData> behaviorNode6 = new Sequence<BehaviorData>(new BehaviorNode<BehaviorData>[]
			{
				behaviorNode2,
				behaviorNode4
			});
            BehaviorNode<BehaviorData> moveToTargetSubtree = BehaviorSubTrees.GetMoveToTargetSubtree();
            return new Selector<BehaviorData>(new BehaviorNode<BehaviorData>[]
			{
				moveToTargetSubtree,
				behaviorNode5,
				behaviorNode6,
				behaviorNode3
			});
        }

        protected DoFleetActionAtPosition()
        {
        }
    }
}
